let canvas = document.getElementById("canvas");
let ctx = canvas.getContext("2d");
let part = 0;
let haveletters = 0;
let activeword = [];
let word = "";
let maxTries = 6;
let usedletters = [];
const CentralTable = document.getElementById("CentralTable");
const btnholder = document.getElementById("btnholder");
const status = document.getElementById("status");

const words = ["ananas", "myš", "pes", "anakonda", "zelí", "aligátor", "legální", "pálivý","jablko", "auto", "stůl", "kočka", "pes", "dům", "strom", "květina", "hory", "moře", "ráno", "večer", "dítě", "město", "vesnice", "škola", "kniha", "telefon", "klíč", "okno", "dveře", "auto", "vlak", "letadlo", "měsíc", "slunce", "hvězda", "úsměv", "smutek", "radost", "nebe", "zahrada", "srdce", "přítel", "rodina", "zvíře", "hudba", "tanec", "film", "televize", "jablko", "zelenina", "ovoce", "chléb", "máslo", "sýr", "káva", "čaj", "deštník", "boty", "kalhoty", "košile"];
const letters = ["a", "á", "b", "c", "č", "d", "ď", "e", "é", "ě", "f", "g", "h", "i", "í", "j", "k", "l", "m", "n", "ň", "o", "ó", "p", "q", "r", "ř", "s", "š", "t", "ť", "u", "ú", "ů", "v", "w", "x", "y", "ý", "z", "ž"];

function isCharacterALetter(char) {
    let found = false, i;
    for (i = 0; i < letters.length; i++) {
        if (char === letters[i]) {found = true;}
    } return found;
}

function initGame() {
    part = 0;
    usedletters = [];
    haveletters = 0;
    word = words[Math.floor(Math.random() * words.length)];
    activeword = word.split('');
    CentralTable.style.boxShadow = "inset 0 0 40px black,0 0 20px black";

    ctx.clearRect(0, 0, canvas.width, canvas.height);

    const plholders = document.getElementById("plholders");
    plholders.innerHTML = activeword.map((_, i) => `<div class='Char-plHolder' id='ch${i}'></div>`).join('');

    const btnholder = document.getElementById("btnholder");
    btnholder.innerHTML = letters.map((letter, i) => 
        `<button onclick='KeyPressedEV("${letter}")' id='lbt${i}'>${letter.toUpperCase()}</button>`
    ).join('');

    document.getElementById("attemptsLeft").textContent = maxTries.toString();

    document.getElementById("status").textContent = "";

}

function KeyPressedEV(char) {
    let isnotthere = true;for (let i = 0; i < usedletters.length; i++) {if (char === usedletters[i]) {isnotthere = false;}}
    if (isCharacterALetter(char) && isnotthere) {
    if (part >= maxTries || haveletters === activeword.length) return;
    usedletters.push(char);


    let found = false;
    for (let i = 0; i < activeword.length; i++) {
        if (activeword[i] === char) {
            found = true;
            haveletters++;
            document.getElementById(`ch${i}`).innerHTML = `<p>${char.toUpperCase()}</p>`;
        }
    }

    const button = document.getElementById(`lbt${letters.indexOf(char)}`);
    if (found) {
        button.style.boxShadow = "inset 0 0 40px #208f01,0 0 20px #002407";
    } else {
        part++;
        drawHangman();
        button.style.boxShadow = "inset 0 0 40px #9b0000,0 0 20px #480000";
        document.getElementById("attemptsLeft").textContent = (6 - part).toString();
    }

    if (part >= maxTries ) {
        gameOver(false);
    } else if (haveletters === activeword.length) {
        gameOver(true);
    }
}}

document.addEventListener("keydown", (event) => {KeyPressedEV(event.key);});




function gameOver(won) {
    if (won) {
        document.getElementById("victory-audio").play();
        CentralTable.style.boxShadow = "inset 0 0 40px #208f01,0 0 20px #002407";
        status.textContent = "Vyhráli jste!";
    } else {
        document.getElementById("lose-audio").play();
        CentralTable.style.boxShadow = "inset 0 0 40px #9b0000,0 0 20px #480000";
        status.textContent = "Prohráli jste. ";
    }
    btnholder.innerHTML += "<button id='play-agin-btn' onclick='initGame()'>Hrát znovu</button>";
}
function drawHangman() {
    ctx.beginPath();
    ctx.fillStyle = "#fff";
    ctx.strokeStyle = "#000";
    ctx.lineWidth = 5;
    ctx.shadowColor = "black";
    ctx.shadowBlur = 20;
    ctx.shadowOffsetX = 0;
    ctx.shadowOffsetY = 0;
    switch (part) {
        case 1: 
            ctx.arc(200, 400, 100, 0, Math.PI * 2, true);
            break;
        case 2: 
            ctx.moveTo(200, 300);
            ctx.lineTo(200, 100);
            break;
        case 3:
            ctx.moveTo(200, 100);
            ctx.lineTo(300, 100);
            break;
        case 4:
            ctx.moveTo(300, 100);
            ctx.lineTo(300, 150);
            break;
        case 5:
            ctx.arc(300, 170, 20, 0, Math.PI * 2, true);
            break;
        case 6:
            ctx.moveTo(300, 190);
            ctx.lineTo(300, 250);
            ctx.moveTo(300, 250);
            ctx.lineTo(320, 300);
            ctx.moveTo(300, 250);
            ctx.lineTo(280, 300);
            ctx.moveTo(280, 210);
            ctx.lineTo(320, 210);
            break;
    }
    ctx.stroke();
}
initGame();
